/*
  softRTC.c
 
*/
#include "simpletools.h"
#include <time.h>
#include <sys/rtc.h>

#define BUFFERLEN 10

void Help();
void Set_Clock();
int getdst();
int prompttime(char *prompt);
void Get_Time();
void Get_Date();


int main()
{
  // Add startup code here.
  uint8_t buffer[40];

  print("This is softRTC\n");
  print("help - for menu\n");
 
  while(1)
  {
    // Add main loop code here.
    print("> ");
    gets(buffer);
    if(!strcmp(buffer, "quit")) break;
    else if(!strcmp(buffer, "help")) Help();
    else if(!strcmp(buffer, "setclock")) Set_Clock();
    else if(!strcmp(buffer, "time")) Get_Time();
    else if(!strcmp(buffer, "date")) Get_Date();
    else
    {
      print("Invalid Command!\n");
    }    
  }
  print("System Stop!\n");  
}

void Help()
{
  print("Commands are: setclock, time, date, quit.\n");
}

void Set_Clock()
{
  struct timeval tv;
  struct tm t;

  t.tm_isdst = getdst();
  t.tm_year = prompttime("Year")-1900;
  t.tm_mon = prompttime("Month")-1;
  t.tm_mday = prompttime("Day of the month");
  t.tm_hour = prompttime("Hour");
  t.tm_min = prompttime("Minute");
  t.tm_sec = prompttime("Second");

  tv.tv_sec = mktime(&t);
  settimeofday(&tv, 0);
}

int getdst()
{
  int rc = 0;

  print("Use daylight savings time [y/n] ? ");
  fflush(stdout);

  rc = (getchar() == 'y') ? 1 : 0;
  getchar();
  return rc;
}

int prompttime(char *prompt)
{
  int rc = 0;
  char *endp;
  char buffer[BUFFERLEN];

  do
  {
    print("Enter %s: ",prompt);
    fflush(stdout);

    fgets(buffer, BUFFERLEN,stdin);
    fflush(stdin);

    rc = strtol(buffer, &endp, 10);

    if(endp == buffer)
    {
      if('\n' == *endp)
      {
        rc = 0;
        break;
      }
      print("Invalid entry \"%c....\" Please enter a number.\n", *endp);
    }
  } while(endp == buffer);
  return rc;
}

void Get_Time()
{
  char timebuff[16];
  time_t now = 0;

  now = time(&now);
  strftime(timebuff,16,"%T",localtime(&now));
  print("%s\n",timebuff);
}

void Get_Date()
{
  char timebuff[16];
  time_t now = 0;

  now = time(&now);
  strftime(timebuff,16,"%b %d, %Y",localtime(&now));
  print("%s\n",timebuff);
}

